#film2cds -- reduces a filmstrip into multiple CDS exposures and imcombines like
#            exposures

procedure film2cds (base,is,ie,cds,imc)

string  base="" {prompt = "Basename of images"}
int     is=1    {prompt = "Starting image index"}
int     ie=10   {prompt = "Ending image index"}
int     cds=1   {prompt = "calculate CDS frames? 1=yes 0=no"}
int     imc=1   {prompt = "calculate imcombine frames? 1=yes 0=no"}

begin

#Declare Variables
string  imbase, fname, imgreset, imgread, imgname, imgnum, imgmean, imgsigma
int     imst, imend, cols, rows, nrows, nframes, j, k, l, sumj, sumk, im

#Start Script
imbase = base
imst = is
imend = ie

if (cds==1) {

  for (i=imst; i<=imend; i+=1 ) {

    if (i < 10) {
      imgnum = "000"+str(i)
      }
    if ((i >= 10) && (i < 100)) {
      imgnum = "00"+str(i)
      }

    if ((i >= 100) && (i < 1000)) {
      imgnum = "0"+str(i)
      }

    if (i >= 1000) {
      imgnum = str(i)
      }

    fname = imbase+imgnum

    imgets(fname, "i_naxis1")
    cols = int(imgets.value)
    rows = cols
    imgets(fname, "i_naxis2")
    nrows = int(imgets.value)
    nframes = nrows / cols

    jj = 1
    kk = 1 + rows
    im = 1

    for (ll=1; ll<nframes; ll+=1) {
      sumj = jj+rows-1
      sumk = kk+rows-1
      imgreset = fname+"[1:"+str(cols)+","+str(jj)+":"+str(sumj)+"]"
      imgread = fname+"[1:"+str(cols)+","+str(kk)+":"+str(sumk)+"]"
      print(im, " ", imgreset, " - ", imgread)
      imgname = "cds"+imgnum+"_"+str(im)
      imarith (operand1=imgreset, op="-", operand2=imgread, result=imgname)

      jj = jj + rows
      kk = kk + rows
      im = im + 1
      }

    jj = 1 + rows
    kk = 1 + rows + rows
    imgreset = fname+"[1:"+str(cols)+",1:"+str(rows)+"]"

    for (ll=1; ll<nframes-1; ll+=1) {
      sumj = jj+rows-1
      sumk = kk+rows-1
      imgread = fname+"[1:"+str(cols)+","+str(kk)+":"+str(sumk)+"]"
      imgname = "cds"+imgnum+"_"+str(im)
      print(im, " ", imgreset, " - ", imgread)
      imarith (operand1=imgreset, op="-", operand2=imgread, result=imgname)

      jj = jj + rows
      kk = kk + rows
      im = im + 1
      }
    print(" ")
    }
  }

if (imc==1) {
  if (imst < 10) {
    imgnum = "000"+str(imst)
    }
  if ((imst >= 10) && (imst < 100)) {
    imgnum = "00"+str(imst)
    }
  if ((imst >= 100) && (imst < 1000)) {
    imgnum = "0"+str(imst)
    }
  if (imst >= 1000) {
    imgnum = str(imst)
    }
  fname = imbase+imgnum
  imgets(fname, "i_naxis1")
  cols = int(imgets.value)
  rows = cols
  imgets(fname, "i_naxis2")
  nrows = int(imgets.value)
  nframes = nrows / cols

  for (jj=1; jj<=(2*nframes-3); jj+=1) {
    print("imcombine ", jj)
    imbase = "cds????_"+str(jj)+".fits"
    imgmean = "mean_"+str(jj)
    imgsigma = "sigma_"+str(jj)
    imcombine (imbase, imgmean, sigma=imgsigma, combine="average", reject="sigclip")
    }
  }

end
